package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.serialization.Codec;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import java.util.function.Supplier;
import javax.annotation.Nullable;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.item.ItemStack;

public class DurableAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.DurableAffix> CODEC = Codec.unit(dev.shadowsoffire.apotheosis.adventure.affix.effect.DurableAffix::new);
  
  public DurableAffix() {
    super(AffixType.DURABILITY);
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return stack.m_41763_();
  }
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    return super.getDescription(stack, rarity, level * 100.0F);
  }
  
  public Component getAugmentingText(ItemStack stack, LootRarity rarity, float level) {
    return (Component)getDescription(stack, rarity, level);
  }
  
  public float getDurabilityBonusPercentage(ItemStack stack, LootRarity rarity, float level, @Nullable ServerPlayer user) {
    return level;
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
  
  public static double duraProd(double result, double element) {
    return result + (1.0D - result) * element;
  }
}
